/* queue.h */

/* BASE is an alias for the basic type of the queue,
 in this case a generic pointer to a variable in memory  */
typedef void * BASE;

typedef struct queue_t *QUEUE;

/* here you can put global variables accessible by other modules 
  using the "extern" modifier      */

QUEUE QUEUE_init( void );
int QUEUE_enqueue( QUEUE q, BASE x );
int QUEUE_dequeue( QUEUE q, BASE *P_x );
int QUEUE_head( QUEUE q, BASE *P_x );
int QUEUE_empty( QUEUE q );
void QUEUE_destroy( QUEUE q );
