/* 
   matrix
*/

#include <stdio.h>
#include <stdlib.h>

#define R1  3
#define C1  4
#define C2  3
/* C1 is the number of column of first matrix, R1 is the number of rows */
/* C2 is the number of column of second matrix and 
it is equal to the number of rows of the second matrix*/

int product(int a[R1][C1], int b[C1][C2], int p[R1][C2]){
    for (int i=0; i<R1; i++) {
        for (int j=0; j<C2; j++){
            p[i][j] = 0;
            /*calculate the scalar product between
             the i-th row of matrix a and the j-th column
             of matrix b */
            for (int k=0 ; k< C1; k++) {
                p[i][j] += a[i][k]* b[k][j];
            }
        }
    } 
    return 0;
}
void print(int * m, int r, int c){
     for (int i=0; i<r; i++) {
         for (int j=0; j<c; j++) {
            printf("%d ", m[i*c+j]);
         }
         printf("\n");
    }
    printf("\n");
}
int main(void)
{
    int   A[R1][C1] = {{1,2,3,5}, 
                     {3,4,0,-4}, 
                     {3,1,0,-4}};
    int   B[C1][C2] = {{0,3,2}, 
                     {-4,-5,0}, 
                     {-6,1,7},
                     {-6,1,-3}};
    int p[R1][C2]; /* matrix for result  */
    print(A, R1,C1);
    product(A, B, p);
    print(p, R1,C2);
    getchar();
    return (SUCCESS);
}
